#include <stdio.h>

#include <Mrm/MrmPublic.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Frame.h>

void button_pushed(Widget w, XtPointer app_data, XtPointer widget_data);

static MrmRegisterArg cb_list[] = {
  { "button_pushed", (XtPointer)button_pushed }
};

main(int argc, char **argv)
{
  Widget         app_shell, top_level;     
  XtAppContext   app;     
  static String  file_names[] = { "simple.uid"};     
  MrmHierarchy   hierarchy_id;     
  MrmType        top_level_class;

  app_shell = XtAppInitialize(&app, "Example", (XrmOptionDescList) NULL, 0, 
			      (Cardinal *) &argc, argv, (String *) NULL, 
			      (ArgList) NULL, 0);
  MrmInitialize();     
  switch (MrmOpenHierarchyPerDisplay(XtDisplay(app_shell), 
				     (MrmCount) XtNumber(file_names), 
				     file_names,              
				     (MrmOsOpenParamPtr *) NULL, 
				     &hierarchy_id)) 
    {     
    case MrmSUCCESS:         
      if (MrmRegisterNames(cb_list, (MrmCount)XtNumber(cb_list)) != MrmSUCCESS)
	fprintf(stderr, "Unable to register callbacks\n");

      if (MrmFetchWidget(hierarchy_id, "simpleWindow",
			 app_shell, &top_level, &top_level_class)
	  != MrmSUCCESS) 
	{
	  fprintf(stderr, "Unable to fetch top-level widget.\n");
        }      

      XtManageChild(top_level);
      XtRealizeWidget(app_shell);

      XtAppMainLoop(app);
      
      if (MrmCloseHierarchy(hierarchy_id) == MrmSUCCESS) 
	{             
	  exit(0);         
	} 
      else 
	{             
	  fprintf(stderr, "Unable to close UID hierarchy.\n");             
	  exit(1);         
	}     
    case MrmNOT_FOUND:         
      fprintf(stderr, "Unable to open UID files.\n");         
      exit (1);     
    default:
      fprintf(stderr, "Unable to open UID hierarchy.\n");
      exit (1);
    }  
}


void button_pushed(Widget w, XtPointer app_data, XtPointer widget_data)
{
  printf("Button pushed\n");
}




